package meerkat.bulletinboard;

import meerkat.protobuf.BulletinBoardAPI.*;
import meerkat.protobuf.Crypto.*;

import java.util.LinkedList;
import java.util.List;

/**
 * Created by Arbel Deutsch Peled on 14-Dec-15.
 *
 * A data structure for holding both a batch message and its signature
 */
public class SignedBatch {

    private List<BatchData> batchDataList;
    private Signature signature;

    public SignedBatch() {
        batchDataList = new LinkedList<BatchData>();
    }

    public SignedBatch(List<BatchData> newDataList) {
        this();
        appendBatchData(newDataList);
    }

    public SignedBatch(List<BatchData> newDataList, Signature newSignature) {
        this(newDataList);
        signature = newSignature;
    }

    public List<BatchData> getBatchDataList() {
        return batchDataList;
    }

    public Signature getSignature() {
        return signature;
    }

    public void appendBatchData(BatchData newBatchData) {
        batchDataList.add(newBatchData);
    }

    public void appendBatchData(List<BatchData> newBatchDataList) {
        batchDataList.addAll(newBatchDataList);
    }


}
